import { DoCheck, ElementRef, EventEmitter, OnInit } from "@angular/core";
import { DefinedDateRange, Options } from "../types";
import dayjs, { Dayjs } from "dayjs";
export declare class DaterangepickerComponent implements OnInit, DoCheck {
    private elem;
    options: Options;
    class: string;
    rangeSelected: EventEmitter<{}>;
    showCalendars: boolean;
    range: string;
    enableApplyButton: boolean;
    areOldDatesStored: boolean;
    fromDate: Dayjs;
    toDate: Dayjs;
    tempFromDate: Dayjs;
    tempToDate: Dayjs;
    oldFromDate: Dayjs;
    oldToDate: Dayjs;
    fromMonth: number;
    toMonth: number;
    fromYear: number;
    toYear: number;
    format: string;
    derivedOptions: Options;
    handleOutsideClick(event: any): void;
    constructor(elem: ElementRef);
    ngDoCheck(): void;
    ngOnInit(): void;
    deriveOptions(isUpdate?: boolean): void;
    setFromDate(value: Dayjs): void;
    getActualFromDate(value: Dayjs): dayjs.Dayjs;
    setToDate(value: Dayjs): void;
    getActualToDate(value: Dayjs): dayjs.Dayjs;
    validateMinMaxDates(): void;
    getValidateFromDate(value: Dayjs): dayjs.Dayjs;
    getValidateToDate(value: Dayjs): dayjs.Dayjs;
    getDayjs(value: string | Dayjs): dayjs.Dayjs;
    getValidateDayjs(value: string | Dayjs): any;
    formatFromDate(event: any): void;
    formatToDate(event: any): void;
    dateChanged(data: any): void;
    monthChanged(data: any): void;
    yearChanged(data: any): void;
    emitRangeSelected(): void;
    storeOldDates(): void;
    restoreOldDates(): void;
    setRange(): void;
    apply(): void;
    cancel(): void;
    clear(): void;
    applyPredefinedRange(data: DefinedDateRange): void;
    toggleCalendars(value: boolean): void;
    updateCalendar(): void;
    getAriaLabel(): string;
}
